<?php 
/************************************************
 Sphider-plus version 2.9 configuration file.

 > > >  DO NOT EDIT THIS FILE. < < < 

Any modification must be done by Admin settings. 
*************************************************/




/******************************* Check for forbidden direct access ************************************/

    if (!defined('_SECURE')) die ("No direct access to configuration file");



/*********************** 
General settings 
***********************/

// Sphider-plus version 
$plus_nr = '2.9';

// Original Sphider version 
$version_nr = '1.3.5';

// IDS impact warn level
$ids_warn = '14';

// IDS impact stop traffic level
$ids_stop = '25';

//Standard charset of your location (e.g. ISO-8859-1)
$home_charset = 'utf-8';

//Administrators email address (logs and info emails will be sent there)
$admin_email = 'admin@localhost';

//Dispatcher email address (info emails will be sent from this account)
$dispatch_email = 'postmaster@localhost';

//Address to localhost document root 
$local = 'http://localhost/publizieren/';

//Folder for thumbnails during search procedure 
$thumb_dir = './include/thumbs';

//Folder for thumbnails during index procedure 
$thumb_folder = './admin/thumbs';

//Folder for XML results 
$xml_dir = './xml';

//Delimiter to separate real tile and transliterated part of media titles 
$delim = ' _-_- ';

// Accept non-ASCII URLS to be added
$idna = 1;

// Show complete list of URLs during import and export
$show_url = 1;

// Default for number of sites per page in Admin backend
$sites_per_page = 50;

// Sort Sites table in Admin section in alphabetic order
$sites_alpha = 1;

// Sort Sites table in Admin section by indexdate, latest on top
$sites_latest = 0;

// Sort Sites table in Admin section by indexdate, oldest on top
$sites_oldest = 0;

// Sort Sites table in Admin section by title
$sites_title = 0;

//  MySQL query cache
$qcache = 1;

//  Don't erase URLs containing 'Must Not include' words
$not_erase = 1;

//  .htaccess protection for admin folder
$htaccess = 0;

// Admin debug mode - Show details from index / re-index procedure, MySQL and PHP error messages
$debug = 2;

// User debug mode - Show details concerning database and cache activity
$debug_user = 0;

// Use 'Intrusion Detection System'
$use_ids = 0;

// Block Internet traffic of IP's detected by 'Intrusion Detection System'
$ids_blocked = 0;

// Free resources when indexing large amount of URLs 
$clear = 0;

// Reset query log during erase and index procedures 
$clear_query = 1;

// Remember new domains found during index procedure 
$auto_add = 0;

// Delete related keywords and links after site delete 
$del_related = 1;

// Template directory
$templ_dir = 'templates';

// Temporary directory, this should be readable and writable
$tmp_dir = 'tmp';

// Name of search script
$search_script = 'search.php';

// Embedded application of Sphider-plus HTML code 
$embedded = '';

// Operating System
$op_system = 'win';

// Availability of cURL library 
$curl = '1';


/*********************** 
Logging settings 
***********************/

//  Disable output of logging data during index / re-index 
$no_log = 0;

//  Enable real-time output of logging data 
$real_log = 0;

//  Interval for real-time Log file update [seconds]
$refresh = 5;

//  Interval until next click will be accepted to increase popularity of a link [seconds]
$click_wait = 60;

// Should log files be kept
$keep_log = 1;

//Log directory, this should be readable and writable
$log_dir = 'log';

// Log format
$log_format = 'html';

//  Send log file by email 
$email_log = 0;


/*********************** 
Spider settings 
***********************/

// Separate between upper- and lower-case queries
$case_sensitive   = 0;

// Sitemap directory, this should be readable and writable 
$smap_dir = 'sitemaps';

// Count of threads for indexing 
$multi_indexer = '1';

// Max. links to be followed per site 
$max_links = '9999';

// Interrupt indexer each x links 
$interrupt = '&nbsp;&nbsp;--';

// Min words per page required for indexing 
$min_words_per_page = 5;

// Words shorter than this will not be indexed
$min_word_length = 3;

// Keyword weight depending on the number of times it appears in a page is capped at this value
$word_upper_bound = 100;

// The length of full text, indexed at each page [0=unlimeted]. 
$text_length = 0;

// If available follow 'sitemap.xml'
$follow_sitemap		= 1;

// Create sitemap.xml file of each indexed site
$create_sitemap		= 0;

// Sitemap name unique for all .xml files 
$smap_unique = '0';

// Convert UTF-16 coded sites into UTF-8 
$utf_16 = '0';

// Crawler can leave domain during indexing
$domaincb = 0;

// Use preferred charset for indexing
$use_prefcharset = 0;

// Indexing depth
$depth = -1;

// Index numbers as well
$index_numbers = 1;

// if this value is set to 1, word in domain name and url path are also indexed,
// so that for example the index of www.php.net returns a positive answer to query 'php' even
// if the word is not included in the page itself.
$index_host = 0;


// Whether to index the Meta tag: Title
$index_meta_title = 1;

// Whether to index the Meta tag: Keywords
$index_meta_keywords = 1;

// Whether to index the Meta tag: Description
$index_meta_description = 1;

// Do not index the full text
$ignore_fulltxt = 0;

// Index PDF files
$index_pdf = 0;

// Index DOC files
$index_doc = 0;

// Index RTF files
$index_rtf = 0;

// Index XLS files
$index_xls = 0;

// Index CSV files
$index_csv = 0;

// Index PPT files
$index_ppt = 0;

// Index ODS files
$index_ods = 0;

// Index ODT files
$index_odt = 0;

//Path to PDF converter
$pdftotext_path = '..\converter\pdftotext';

//Path to DOC converter
$catdoc_path = '..\converter\catdoc.exe';

//Path to PPT converter
$catppt_path = '..\converter\catppt.exe';

//Multibyte extention of PHP
$mb = '1';

// Index media files (general selection)
$index_media = '0';

// Index image files 
$index_image = '0';

// Minimum size for image files (width)
$min_image_x = '50';

// Minimum size for image files (height)
$min_image_y = '50';

// Index audio files 
$index_audio = '0';

// Index video files 
$index_video = '0';

// Index embeded media files 
$index_embeded = '1';

// Index alt tag of images 
$index_alt = '0';

// Suppress file suffix from image names 
$suppress_suffix = '0';

// Index ID3 tags 
$index_id3 = '1';

// Index duplicate media on different pages 
$dup_media = '1';

// Index external hosted media content 
$ex_media = '1';

// Index RSS and Atom feeds 
$index_rss = '1';

// Follow CDATA tags in feeds 
$cdata = '1';

// Index Dublin Core tags in RDF feeds 
$dc = '1';

// Follow PREFERRED directive in RSD feeds 
$preferred = '1';

// Index RAR files and archives 
$index_rar = '0';

// Index ZIP files and archives 
$index_zip = '0';

// Index framesets 
$index_framesets = '1';

// Index iframes 
$index_iframes = '1';

// Jump to iframe directly 
$iframe_link = '1';

// Index media conent with respect toframe/iframe position 
$abslinks = '0';

// Time interval for auto re-index 
$interval = 'never';

// Auto re-index counter 
$intv_count = '9999';

// Language of 'common word' list 
$use_common = 'none';

// Use any word in whitelist to enable page indexing
$use_white1 = '0';

// Use all words of whitelist to enable page indexing
$use_white2 = '0';

// Use blacklist to prevent page indexing
$use_black = '1';

// Use blacklist to delete query input
$kill_query = '1';

// Use div-list to ignore some divs
$not_divs = '0';

// Use div-list to index only div content
$use_divs = '0';

// Use element-list to ignore some HTML elements
$not_elems = '0';

// Use element-list to index only HTML element content
$use_elems = '0';

// Delete HTML elements defined like & l t ; element & g t ; 
$del_elems = '0';

// Convert punycode URLs in full text into readable
$conv_puny = '1';

// Delete secondary characters at the beginning and end of words
$del_secchars = '1';

// Delete secondary characters inside of words
$del_seccharin = '0';

// Use simple quotes 
$quotes = '1';

// Convert double quotes 
$dup_quotes = '1';

// Convert accents into their basic vowels 
$vowels = '1';

// User agent string 
$user_agent = 'Sphider-plus';

// Browser http_agent_string 
$browser_string = '0';

// Always use Firefox HTTP_USER_AGENT 
$default_agent = '1';

// Use charset as supplied by the server 
$server_char = '1';

// Minimal delay between page downloads 
$min_delay = 0;

// Use word stemming for language 
$stem_words = 'none';

// Strip session ids (PHPSESSID, JSESSIONID, ASPSESSIONID, sid) 
$strip_sessids = 1;

// additionally strip session id: s 
$strip_s_sessids = 0;

// Allow other hosts in same domain for all found links, and also ignore www. 
$other_host = 0;

// For redirected links allow other hosts in same domain, and also ignore www. 
$redir_host = 1;

// Crawler can leave domain, but only for canonical links. 
$cano_leave = 0;

// Follow redirections found in JavaScript. 
$js_reloc = 1;

// Delete duplicates in link path. 
$dup_path = 0;

// Index only documents 
$only_docs = 0;

// Index only links and their titles 
$only_links = 0;

// Enable link-check instead of reindex 
$link_check = 0;

// Enable index and re-index for pages with duplicate content 
$dup_content = 0;

// Split words into their basic parts, separated at hyphens, dots and commas 
$div_all = 0;

// Split words into their basic parts, separated only at hyphens 
$div_hyphen = 1;

// Decode BBcode during index 
$bb_decode = 0;

// Decode UTF-8 HTML entities during index 
$ent_decode = 1;

// Support Greek language 
$greek = 0;

// Support Cyrillic language 
$cyrillic = 0;

// Perform a segmentation of Chinese text during index 
$cn_seg = 0;

// Perform a segmentation of Japanese text during index 
$jp_seg = 0;

// User name1 for password protected pages 
$user1 = '0';

// Password1 for password protected pages 
$pwd1 = '0';

// User name2 for password protected pages 
$user2 = '0';

// Password2 for password protected pages 
$pwd2 = '0';

// User name3 for password protected pages 
$user3 = '0';

// Password3 for password protected pages 
$pwd3 = '0';


/*********************** 
Search settings 
***********************/

//Language of the search page 
$language = 'en';

//Auto detect client language
$auto_lng = '1';

// Prevent queries from harvester, bots and known evial user-agents
$kill_black_uas = 1;

// Prevent queries from Meta search engines like Google
$kill_black_ips = 1;

// Prevent queries causing XSS attacks, Tag inclusions, Shell and JavaScript exec.
$block_attacks = 1;

//Use cache for search results
$use_cache = '0';

//Cache size [MB] for text search results
$tcache_size = '2';

//Cache size [MB] for media search results
$mcache_size = '2';

//Max results/links per query in text cache
$max_ctresults = '9999';

//Max results/links per query in media cache
$max_cmresults = '9999';

//Clear text and media cache during re-index procedure
$clear_cache = '1';

// Template design/Directory in templates dir
$template = 'Sphider-plus';

// Title for Results Page
$mytitle = 'Sphider-plus';

//Type of highlighting for found keywords 
$mark = 'markblue';

// Default for number of results per page
$results_per_page = 10;

// Can speed up searches on large database (should be 0)
$bound_search_result = 0;

// Number of links shown to next pages
$links_to_next = 9;

// Show elapsed time in result header
$elapsed = 0;

// Show meta description in results page if it exists, otherwise show an extract from the page text.
$show_meta_description = 0;

// Show warning message if search string was found only in title or url.
$show_warning = 1;

// Advanced query form, shows and/or buttons
$advanced_search = 1;

// Show actual result number for each result
$show_res_num = 1;	

// Query scores are not shown if set to 0
$show_query_scores = 1;	

// Show the URL of each result
$show_res_url = 1;	

// Search without quotes
$no_quotes= 1;	

// Queries with numbers become wildsearch
$wild_num= 1;	

// Translitate queries from Latin characters to Greek 
$translit_el= 0;

//Accept Greek vowels without accents 
$noacc_el= 0;	

 // Display category list
$show_categories = 0;

 // Display category selection at each result
$more_catres = 0;

// Max length of page title given in results page
$title_length		= 80;

// Max length of URL given in results page
$url_length		= 80;

// Length of page description given in results page
$desc_length = 250;

// Max hits shown per link in results page
$max_hits		= 1;

// Show order of result listing as headline
$show_sort = 0;

// Show media results as well as text results in result page
$show_media = 0;

// Limit media results, if presented togetherr with text results in result page
$limit_media = 8;

// Search for media results also in EXIF and ID3 info
$search_id3 = 0;

// Chronological order of media result listing
$sort_media = 1;

// Show 'Most popular searches' at the bottom of result pages
$most_pop = 1;

// Suppress zero results in 'Most popular searches'
$no_zeros = 1;

// Show 3D tag cloud in 'Most popular searches'
$tag_cloud = 0;

// Show 3D tag cloud in differernt colors for each query hit
$color_cloud = 0;

// Number of rows for 'Most popular searches'
$pop_rows = 5;

// Min. relevance level (%) to be shown at result pages
$relevance = 0;

// Max. quantity of results for result listing
$max_results = 999;

// Show db content at the bottom of result listing
$db_content = 0;

// Show 'User may suggest a Url' at the bottom of result pages'
$add_url = 1;

// Use authentification for suggested URLs
$add_auth = 0;

// Inform about user suggestion by e-mail
$addurl_info = 1;

// Perform a WHOIS check for suggested URLs
$whois_user = 0;

// Perform a WHOIS check for suggested URLs in Admin backend
$whois_admin = 0;

// Use extended suffix list for WHOIS checks
$whois_ext = 0;

// Use Captcha for Addurl-form
$captcha = 0;


/*********************** 
Suggest framework
***********************/

// Enable spelling suggestions (Did you mean...)
$did_you_mean_enabled = 1;

// Define min. character input for suggestion 
$min_sug_chars = 1;

// Search for suggestions in query log 
$suggest_history = 0;

// Search for suggestions in keywords 
$suggest_keywords = 1;

// Build suggestions also for phrases 
$suggest_phrases = 1;

// Search for suggestions in id3 tags 
$suggest_id3 = 0;

// Show number of results in suggestion table 
$show_hits = 0;

// Limit number of suggestions 
$suggest_rows = 20;


/*********************** 
Weights and result order
***********************/

// Relative weight of a word in the title of a webpage
$title_weight = 20;

// Relative weight of a word in the domain name
$domain_weight = 60;

// Relative weight of a word in the path name
$path_weight = 10;

// Relative weight of a word in meta_keywords
$meta_weight = 5;

// Defines multiplier for words in main URLs (domains)
$domain_mul = 1;

// Defines method of chronological order for result listing
$sort_results = 1;

// Name of promoted domain
$dompromo = '';

// Name of promoted catchword
$keypromo = '';

// Max results per domain in result listing
$dom_count = '3';

?>